#define Controlboy3
#include "hc11.h"
#include <stdio.h>


void
wait(cnt)
{	int i, c;
	for (;cnt>0; cnt--)
	    for (i=0; i<100; i++);
}

/******************************* lcd *****************************************/

#define LCDBUFSZ 16
char lcdbuf[LCDBUFSZ]="                ";

char lcdpos;
void
lcdnib(unsigned char c)
{	PORTC = (c & 0x4F) | 0x30;
	PORTC |= 0x80;		/* EN = 1 500 ns	*/
	PORTC &= 0x7F;
}

void
lcdnibw(unsigned char c)
{	lcdnib(c);
	wait(0);
}

void
lcdputc(unsigned char c)
{	lcdnib(c>>4);
	lcdnibw(c&0xF);
}

void
lcdinit(void)
{
	DDRD  = 0;			/* PD5=PD4=PD3=PD2=input */
	SCONF = 0x4C;			/* B,C = sorties */
	PORTC = 0x30;
	wait(5);		/* 15 ms		*/
	lcdnib(3);		/* lcd = 3		*/
	wait(1);		/* 4.1 ms		*/
	lcdnib(3);		/* lcd = 3		*/
	wait(0);		/* .1 ms		*/
	lcdnibw(3);		/* lcd = 3 40us		*/
	lcdnibw(2);		/* lcd = 2 40us		*/
	lcdputc(0x28);		/*passage en 4 bits*/
	lcdputc(0x08);		/* display off		*/
	lcdputc(0x01);		/* clear display	*/
	wait(1);
	lcdputc(0x06);		/*incrementation affichage fixe*/
	lcdputc(0x0E);		/* display on , cursor on*/
/*	lcdputc(0x14);		/* curseur move right*/
	lcdputc(0x80);		/*curseur en 0*/
	lcdpos=0;
}

/*int
putchar(char c)			/* library function	*/
/*{	char *s;
	for (s=lcdbuf; s< lcdbuf +LCDBUFSZ-1; s++)
		*s = s[1];
	*s = c ;
	lcdputc(0x80);
	for (s=lcdbuf; s< lcdbuf +LCDBUFSZ; s++){
		if (s==(lcdbuf+8))
			lcdputc(0x80+0x28);
		lcdnib ((*s >>4) | 0x40);
		lcdnibw( *s      | 0x40);
	}
	return c;
}*/

int putchar(char c)
/*nouvelle version sans gestion de buffer*/
{
	if (lcdpos>7) lcdputc(0x80+0x40+lcdpos-8);
	lcdnib ((c >>4) | 0x40);
	lcdnibw( c      | 0x40);
	lcdpos++;
	return c;
}

void gotox(unsigned char c)
{
	lcdpos=c-1;
	if (c<9) c--;
	if (c>8) c+=0x37;
	lcdputc(0x80 + c);
}


char
keyget(void)
{	static char old_key;
	char old_c = PORTC;
	char x = 0;

	PORTC = (PORTC | 0x7 ) & 0xF7;	/* K=0 J=1 H=1 G=1 */
	if ((PORTD&0x04)==0) x='1';
	if ((PORTD&0x08)==0) x='2';
	if ((PORTD&0x10)==0) x='3';
	PORTC ^= 0x0C;			/* K=1 J=0 H=1 G=1 */
	if ((PORTD&0x04)==0) x='4';
	if ((PORTD&0x08)==0) x='5';
	if ((PORTD&0x10)==0) x='6';
	PORTC ^= 0x06;			/* K=1 J=1 H=0 G=1 */
	if ((PORTD&0x04)==0) x='7';
	if ((PORTD&0x08)==0) x='8';
	if ((PORTD&0x10)==0) x='9';
	PORTC ^= 0x03;			/* K=1 J=1 H=1 G=0 */
	if ((PORTD&0x04)==0) x='*';
	if ((PORTD&0x08)==0) x='0';
	if ((PORTD&0x10)==0) x='#';

	PORTC = old_c;
	if (x==old_key)
		return 0;
	old_key = x;
	return x;
}
