/*
Chaque caractre reu est copier dans un buffer par une
routine d'interruption.
Les fonction putsci et getsci sont sur SCI en IT, 
 */
#define Controlboy3
#include <hc11.h>

#define SIZE	40	/* taille buffer */
#define TDRE	0x80	

/*	Variables globales */
char buffer[SIZE];	/* buffer de reception */
char *ptlec;		/* pointeur de lecture */
char *ptecr;		/* pointeur d'criture */

/*	Character reception d'un caractre.
 *	boucle jusqu' rception.
 */
char getsci(void)
	{
	char c;				

	while (ptlec == ptecr)		
		;
	c = *ptlec++;			
	if (ptlec >= &buffer[SIZE])
		ptlec = buffer;
	return (c);
	}

/*	emission d'un caractre
 */
void putsci(char c)
	{
	while (!(SCSR & TDRE))	
		;
	SCDR = c;		
	}

/* Routine d'interruption
place le carcactre recu dans le buffer*/
#pragma interrupt_handler recept
void recept(void)
	{
char c;	
	asm(" staa %c ");	/*attention ce doit tre la premire instruction */
				/*du sp d'IT, le moniteur retournant le caractre dans acca*/
	*ptecr++ = c;		
	if (ptecr >= &buffer[SIZE]) ptecr = buffer;
	}

/* initialisation du pseudo vecteur SCI sur CBOY
permet de conserver l'accs au moniteur, les octets 0  6 sont rservs*/
void initsci()
	{
	ptecr = ptlec = buffer;		/* initialise les pointeurs */
	asm(" ldd #%recept ");		/*positionne pseudo vecteur*/
	asm(" std $fe ");
	asm(" cli ");			/* autoriser les interruptions */
	}

/* retourne une chaine de caractre*/
char *getstsci(char *s)
	{
	char *r = s;
	int c;

	while ((c = getsci()) != '*') /*placer ici le caractre de fin*/
		*s++ = c;
	*s = 0;
	return r;
	}
/* envoie une chaine de caractre*/
int putstsci(char *s)
	{
	int n;

	for (n = 0; *s; n++, s++)
		putsci(*s);
	putsci('\n');
	return 1;
	}

